# -*- coding: utf-8 -*-

import os
import sys
import urlparse,urllib,urllib2

import xbmc
import xbmcgui
import xbmcaddon

import windowtools
from windowtools import *

import plugintools
import navigation
from item import Item

class EpisodesWindow(xbmcgui.WindowXML):

    def __init__(self, xml_name, fallback_path):
        plugintools.log("EpisodesWindow.__init__ xml_name="+xml_name+" fallback_path="+fallback_path)

        self.first_time = False
        self.parent_item = None

        self.itemlist = None

    def setParentItem(self,item):
        self.parent_item = item

    def setItemlist(self,itemlist):
        plugintools.log("EpisodesWindow.setItemlist")

        self.itemlist = []

        for item in itemlist:
            plugintools.log("EpisodesWindow.setItemlist item="+item.tostring())
            self.itemlist.append(item)

    def onInit( self ):
        plugintools.log("EpisodesWindow.onInit")

        if self.first_time == True:
            return
        
        self.first_time = True

        self.control_list = self.getControl(100)

        if self.itemlist is None:
            next_items = navigation.get_next_items( self.parent_item )
            self.setItemlist(next_items)

        for item in self.itemlist:

            plugintools.log("EpisodesWindow.onInit title="+item.title+", icon="+item.thumbnail)

            list_item = xbmcgui.ListItem( item.title )
            if item.watched=="true":
                list_item.setArt( {"thumb": "watched2.png"} )
            list_item.setArt( {"poster": item.thumbnail} )

            self.control_list.addItem(list_item)

        self.setFocusId(100)
        self.getControl(400).setVisible(False)

    def onAction(self, action):
        plugintools.log("EpisodesWindow.onAction action="+windowtools.action_to_string(action))

        if action == ACTION_PARENT_DIR or action==ACTION_PREVIOUS_MENU or action==ACTION_PREVIOUS_MENU2:
            self.close()

        pos = self.control_list.getSelectedPosition()

        if pos>len(self.itemlist):
            return

        item = self.itemlist[pos]
        
        self.getControl(101).setText(item.plot)

        if action == ACTION_SELECT_ITEM or action == ACTION_MOUSE_LEFT_CLICK:

            if self.getFocusId()==100:

                next_window = navigation.get_window_for_item( item )
                next_window.setParentItem(item)
                navigation.push_window(next_window)

                next_window.doModal()
                del next_window

            # Search
            elif self.getFocusId()==301:
                text_to_search = plugintools.keyboard_input("","Type what you want to search for")

                if text_to_search=="":
                    return

                item = Item( action="globalsearch" , url=text_to_search, view="menu" )

                next_window = navigation.get_window_for_item( item )
                next_window.setParentItem(item)
                navigation.push_window(next_window)

                next_window.doModal()
                del next_window

            # Settings
            elif self.getFocusId()==302:
                plugintools.open_settings_dialog()

            # Home
            elif self.getFocusId()==303:
                navigation.go_to_home_window()

    def onFocus( self, control_id ):
        plugintools.log("EpisodesWindow.onFocus "+repr(control_id))

        pos = self.control_list.getSelectedPosition()
        item = self.itemlist[pos]

        if item.plot!="":
            self.getControl(101).setText(item.plot)

    def onClick( self, control_id ):
        plugintools.log("EpisodesWindow.onClick "+repr(control_id))
        pass

    def onControl(self, control):
        plugintools.log("EpisodesWindow.onClick "+repr(control))
        pass
